# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard open-source IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six
from tb_rest_client.models.models_ce.version_load_request import VersionLoadRequest  # noqa: F401,E501

class EntityTypeVersionLoadRequest(VersionLoadRequest):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'entity_types': 'dict(str, EntityTypeVersionLoadConfig)',
        'rollback_on_error': 'bool'
    }
    if hasattr(VersionLoadRequest, "swagger_types"):
        swagger_types.update(VersionLoadRequest.swagger_types)

    attribute_map = {
        'entity_types': 'entityTypes',
        'rollback_on_error': 'rollbackOnError'
    }
    if hasattr(VersionLoadRequest, "attribute_map"):
        attribute_map.update(VersionLoadRequest.attribute_map)

    def __init__(self, entity_types=None, rollback_on_error=None, *args, **kwargs):  # noqa: E501
        """EntityTypeVersionLoadRequest - a model defined in Swagger"""  # noqa: E501
        self._entity_types = None
        self._rollback_on_error = None
        self.discriminator = None
        if entity_types is not None:
            self.entity_types = entity_types
        if rollback_on_error is not None:
            self.rollback_on_error = rollback_on_error
        VersionLoadRequest.__init__(self, *args, **kwargs)

    @property
    def entity_types(self):
        """Gets the entity_types of this EntityTypeVersionLoadRequest.  # noqa: E501


        :return: The entity_types of this EntityTypeVersionLoadRequest.  # noqa: E501
        :rtype: dict(str, EntityTypeVersionLoadConfig)
        """
        return self._entity_types

    @entity_types.setter
    def entity_types(self, entity_types):
        """Sets the entity_types of this EntityTypeVersionLoadRequest.


        :param entity_types: The entity_types of this EntityTypeVersionLoadRequest.  # noqa: E501
        :type: dict(str, EntityTypeVersionLoadConfig)
        """

        self._entity_types = entity_types

    @property
    def rollback_on_error(self):
        """Gets the rollback_on_error of this EntityTypeVersionLoadRequest.  # noqa: E501


        :return: The rollback_on_error of this EntityTypeVersionLoadRequest.  # noqa: E501
        :rtype: bool
        """
        return self._rollback_on_error

    @rollback_on_error.setter
    def rollback_on_error(self, rollback_on_error):
        """Sets the rollback_on_error of this EntityTypeVersionLoadRequest.


        :param rollback_on_error: The rollback_on_error of this EntityTypeVersionLoadRequest.  # noqa: E501
        :type: bool
        """

        self._rollback_on_error = rollback_on_error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EntityTypeVersionLoadRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EntityTypeVersionLoadRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
