# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard open-source IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six

class OAuth2ClientLoginInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'icon': 'str',
        'url': 'str'
    }

    attribute_map = {
        'name': 'name',
        'icon': 'icon',
        'url': 'url'
    }

    def __init__(self, name=None, icon=None, url=None):  # noqa: E501
        """OAuth2ClientLoginInfo - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._icon = None
        self._url = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if icon is not None:
            self.icon = icon
        if url is not None:
            self.url = url

    @property
    def name(self):
        """Gets the name of this OAuth2ClientLoginInfo.  # noqa: E501

        OAuth2 client name  # noqa: E501

        :return: The name of this OAuth2ClientLoginInfo.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OAuth2ClientLoginInfo.

        OAuth2 client name  # noqa: E501

        :param name: The name of this OAuth2ClientLoginInfo.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def icon(self):
        """Gets the icon of this OAuth2ClientLoginInfo.  # noqa: E501

        Name of the icon, displayed on OAuth2 log in button  # noqa: E501

        :return: The icon of this OAuth2ClientLoginInfo.  # noqa: E501
        :rtype: str
        """
        return self._icon

    @icon.setter
    def icon(self, icon):
        """Sets the icon of this OAuth2ClientLoginInfo.

        Name of the icon, displayed on OAuth2 log in button  # noqa: E501

        :param icon: The icon of this OAuth2ClientLoginInfo.  # noqa: E501
        :type: str
        """

        self._icon = icon

    @property
    def url(self):
        """Gets the url of this OAuth2ClientLoginInfo.  # noqa: E501

        URI for OAuth2 log in. On HTTP GET request to this URI, it redirects to the OAuth2 provider page  # noqa: E501

        :return: The url of this OAuth2ClientLoginInfo.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this OAuth2ClientLoginInfo.

        URI for OAuth2 log in. On HTTP GET request to this URI, it redirects to the OAuth2 provider page  # noqa: E501

        :param url: The url of this OAuth2ClientLoginInfo.  # noqa: E501
        :type: str
        """

        self._url = url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OAuth2ClientLoginInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OAuth2ClientLoginInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
