# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard open-source IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six

class TenantProfileData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'configuration': 'OneOfTenantProfileDataConfiguration',
        'queue_configuration': 'list[TenantProfileQueueConfiguration]'
    }

    attribute_map = {
        'configuration': 'configuration',
        'queue_configuration': 'queueConfiguration'
    }

    def __init__(self, configuration=None, queue_configuration=None):  # noqa: E501
        """TenantProfileData - a model defined in Swagger"""  # noqa: E501
        self._configuration = None
        self._queue_configuration = None
        self.discriminator = None
        if configuration is not None:
            self.configuration = configuration
        if queue_configuration is not None:
            self.queue_configuration = queue_configuration

    @property
    def configuration(self):
        """Gets the configuration of this TenantProfileData.  # noqa: E501

        Complex JSON object that contains profile settings: max devices, max assets, rate limits, etc.  # noqa: E501

        :return: The configuration of this TenantProfileData.  # noqa: E501
        :rtype: OneOfTenantProfileDataConfiguration
        """
        return self._configuration

    @configuration.setter
    def configuration(self, configuration):
        """Sets the configuration of this TenantProfileData.

        Complex JSON object that contains profile settings: max devices, max assets, rate limits, etc.  # noqa: E501

        :param configuration: The configuration of this TenantProfileData.  # noqa: E501
        :type: OneOfTenantProfileDataConfiguration
        """

        self._configuration = configuration

    @property
    def queue_configuration(self):
        """Gets the queue_configuration of this TenantProfileData.  # noqa: E501

        JSON array of queue configuration per tenant profile  # noqa: E501

        :return: The queue_configuration of this TenantProfileData.  # noqa: E501
        :rtype: list[TenantProfileQueueConfiguration]
        """
        return self._queue_configuration

    @queue_configuration.setter
    def queue_configuration(self, queue_configuration):
        """Sets the queue_configuration of this TenantProfileData.

        JSON array of queue configuration per tenant profile  # noqa: E501

        :param queue_configuration: The queue_configuration of this TenantProfileData.  # noqa: E501
        :type: list[TenantProfileQueueConfiguration]
        """

        self._queue_configuration = queue_configuration

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TenantProfileData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TenantProfileData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
