# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard open-source IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six

class WidgetsBundle(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'WidgetsBundleId',
        'created_time': 'int',
        'tenant_id': 'TenantId',
        'alias': 'str',
        'title': 'str',
        'image': 'str',
        'scada': 'bool',
        'description': 'str',
        'order': 'int',
        'version': 'int',
        'name': 'str'
    }

    attribute_map = {
        'id': 'id',
        'created_time': 'createdTime',
        'tenant_id': 'tenantId',
        'alias': 'alias',
        'title': 'title',
        'image': 'image',
        'scada': 'scada',
        'description': 'description',
        'order': 'order',
        'version': 'version',
        'name': 'name'
    }

    def __init__(self, id=None, created_time=None, tenant_id=None, alias=None, title=None, image=None, scada=None, description=None, order=None, version=None, name=None):  # noqa: E501
        """WidgetsBundle - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_time = None
        self._tenant_id = None
        self._alias = None
        self._title = None
        self._image = None
        self._scada = None
        self._description = None
        self._order = None
        self._version = None
        self._name = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if created_time is not None:
            self.created_time = created_time
        if tenant_id is not None:
            self.tenant_id = tenant_id
        if alias is not None:
            self.alias = alias
        if title is not None:
            self.title = title
        if image is not None:
            self.image = image
        if scada is not None:
            self.scada = scada
        if description is not None:
            self.description = description
        if order is not None:
            self.order = order
        if version is not None:
            self.version = version
        if name is not None:
            self.name = name

    @property
    def id(self):
        """Gets the id of this WidgetsBundle.  # noqa: E501


        :return: The id of this WidgetsBundle.  # noqa: E501
        :rtype: WidgetsBundleId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WidgetsBundle.


        :param id: The id of this WidgetsBundle.  # noqa: E501
        :type: WidgetsBundleId
        """

        self._id = id

    @property
    def created_time(self):
        """Gets the created_time of this WidgetsBundle.  # noqa: E501

        Timestamp of the Widget Bundle creation, in milliseconds  # noqa: E501

        :return: The created_time of this WidgetsBundle.  # noqa: E501
        :rtype: int
        """
        return self._created_time

    @created_time.setter
    def created_time(self, created_time):
        """Sets the created_time of this WidgetsBundle.

        Timestamp of the Widget Bundle creation, in milliseconds  # noqa: E501

        :param created_time: The created_time of this WidgetsBundle.  # noqa: E501
        :type: int
        """

        self._created_time = created_time

    @property
    def tenant_id(self):
        """Gets the tenant_id of this WidgetsBundle.  # noqa: E501


        :return: The tenant_id of this WidgetsBundle.  # noqa: E501
        :rtype: TenantId
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this WidgetsBundle.


        :param tenant_id: The tenant_id of this WidgetsBundle.  # noqa: E501
        :type: TenantId
        """

        self._tenant_id = tenant_id

    @property
    def alias(self):
        """Gets the alias of this WidgetsBundle.  # noqa: E501

        Unique alias that is used in widget types as a reference widget bundle  # noqa: E501

        :return: The alias of this WidgetsBundle.  # noqa: E501
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Sets the alias of this WidgetsBundle.

        Unique alias that is used in widget types as a reference widget bundle  # noqa: E501

        :param alias: The alias of this WidgetsBundle.  # noqa: E501
        :type: str
        """

        self._alias = alias

    @property
    def title(self):
        """Gets the title of this WidgetsBundle.  # noqa: E501

        Title used in search and UI  # noqa: E501

        :return: The title of this WidgetsBundle.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this WidgetsBundle.

        Title used in search and UI  # noqa: E501

        :param title: The title of this WidgetsBundle.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def image(self):
        """Gets the image of this WidgetsBundle.  # noqa: E501

        Relative or external image URL. Replaced with image data URL (Base64) in case of relative URL and 'inlineImages' option enabled.  # noqa: E501

        :return: The image of this WidgetsBundle.  # noqa: E501
        :rtype: str
        """
        return self._image

    @image.setter
    def image(self, image):
        """Sets the image of this WidgetsBundle.

        Relative or external image URL. Replaced with image data URL (Base64) in case of relative URL and 'inlineImages' option enabled.  # noqa: E501

        :param image: The image of this WidgetsBundle.  # noqa: E501
        :type: str
        """

        self._image = image

    @property
    def scada(self):
        """Gets the scada of this WidgetsBundle.  # noqa: E501

        Whether widgets bundle contains SCADA symbol widget types.  # noqa: E501

        :return: The scada of this WidgetsBundle.  # noqa: E501
        :rtype: bool
        """
        return self._scada

    @scada.setter
    def scada(self, scada):
        """Sets the scada of this WidgetsBundle.

        Whether widgets bundle contains SCADA symbol widget types.  # noqa: E501

        :param scada: The scada of this WidgetsBundle.  # noqa: E501
        :type: bool
        """

        self._scada = scada

    @property
    def description(self):
        """Gets the description of this WidgetsBundle.  # noqa: E501

        Description  # noqa: E501

        :return: The description of this WidgetsBundle.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this WidgetsBundle.

        Description  # noqa: E501

        :param description: The description of this WidgetsBundle.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def order(self):
        """Gets the order of this WidgetsBundle.  # noqa: E501

        Order  # noqa: E501

        :return: The order of this WidgetsBundle.  # noqa: E501
        :rtype: int
        """
        return self._order

    @order.setter
    def order(self, order):
        """Sets the order of this WidgetsBundle.

        Order  # noqa: E501

        :param order: The order of this WidgetsBundle.  # noqa: E501
        :type: int
        """

        self._order = order

    @property
    def version(self):
        """Gets the version of this WidgetsBundle.  # noqa: E501


        :return: The version of this WidgetsBundle.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this WidgetsBundle.


        :param version: The version of this WidgetsBundle.  # noqa: E501
        :type: int
        """

        self._version = version

    @property
    def name(self):
        """Gets the name of this WidgetsBundle.  # noqa: E501

        Same as title of the Widget Bundle. Read-only field. Update the 'title' to change the 'name' of the Widget Bundle.  # noqa: E501

        :return: The name of this WidgetsBundle.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this WidgetsBundle.

        Same as title of the Widget Bundle. Read-only field. Update the 'title' to change the 'name' of the Widget Bundle.  # noqa: E501

        :param name: The name of this WidgetsBundle.  # noqa: E501
        :type: str
        """

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WidgetsBundle, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WidgetsBundle):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
