# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard Professional Edition IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0PE
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six

class Converter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'ConverterId',
        'created_time': 'int',
        'tenant_id': 'TenantId',
        'name': 'str',
        'type': 'str',
        'debug_mode': 'bool',
        'configuration': 'JsonNode',
        'additional_info': 'JsonNode',
        'edge_template': 'bool',
        'version': 'int'
    }

    attribute_map = {
        'id': 'id',
        'created_time': 'createdTime',
        'tenant_id': 'tenantId',
        'name': 'name',
        'type': 'type',
        'debug_mode': 'debugMode',
        'configuration': 'configuration',
        'additional_info': 'additionalInfo',
        'edge_template': 'edgeTemplate',
        'version': 'version'
    }

    def __init__(self, id=None, created_time=None, tenant_id=None, name=None, type=None, debug_mode=None, configuration=None, additional_info=None, edge_template=None, version=None):  # noqa: E501
        """Converter - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_time = None
        self._tenant_id = None
        self._name = None
        self._type = None
        self._debug_mode = None
        self._configuration = None
        self._additional_info = None
        self._edge_template = None
        self._version = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if created_time is not None:
            self.created_time = created_time
        if tenant_id is not None:
            self.tenant_id = tenant_id
        self.name = name
        self.type = type
        if debug_mode is not None:
            self.debug_mode = debug_mode
        if configuration is not None:
            self.configuration = configuration
        if additional_info is not None:
            self.additional_info = additional_info
        if edge_template is not None:
            self.edge_template = edge_template
        if version is not None:
            self.version = version

    @property
    def id(self):
        """Gets the id of this Converter.  # noqa: E501


        :return: The id of this Converter.  # noqa: E501
        :rtype: ConverterId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Converter.


        :param id: The id of this Converter.  # noqa: E501
        :type: ConverterId
        """

        self._id = id

    @property
    def created_time(self):
        """Gets the created_time of this Converter.  # noqa: E501

        Timestamp of the converter creation, in milliseconds  # noqa: E501

        :return: The created_time of this Converter.  # noqa: E501
        :rtype: int
        """
        return self._created_time

    @created_time.setter
    def created_time(self, created_time):
        """Sets the created_time of this Converter.

        Timestamp of the converter creation, in milliseconds  # noqa: E501

        :param created_time: The created_time of this Converter.  # noqa: E501
        :type: int
        """

        self._created_time = created_time

    @property
    def tenant_id(self):
        """Gets the tenant_id of this Converter.  # noqa: E501


        :return: The tenant_id of this Converter.  # noqa: E501
        :rtype: TenantId
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this Converter.


        :param tenant_id: The tenant_id of this Converter.  # noqa: E501
        :type: TenantId
        """

        self._tenant_id = tenant_id

    @property
    def name(self):
        """Gets the name of this Converter.  # noqa: E501

        Unique Converter Name in scope of Tenant  # noqa: E501

        :return: The name of this Converter.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Converter.

        Unique Converter Name in scope of Tenant  # noqa: E501

        :param name: The name of this Converter.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def type(self):
        """Gets the type of this Converter.  # noqa: E501

        The type of the converter to process incoming or outgoing messages  # noqa: E501

        :return: The type of this Converter.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Converter.

        The type of the converter to process incoming or outgoing messages  # noqa: E501

        :param type: The type of this Converter.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["UPLINK", "DOWNLINK"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def debug_mode(self):
        """Gets the debug_mode of this Converter.  # noqa: E501

        Boolean flag to enable/disable saving received messages as debug events  # noqa: E501

        :return: The debug_mode of this Converter.  # noqa: E501
        :rtype: bool
        """
        return self._debug_mode

    @debug_mode.setter
    def debug_mode(self, debug_mode):
        """Sets the debug_mode of this Converter.

        Boolean flag to enable/disable saving received messages as debug events  # noqa: E501

        :param debug_mode: The debug_mode of this Converter.  # noqa: E501
        :type: bool
        """

        self._debug_mode = debug_mode

    @property
    def configuration(self):
        """Gets the configuration of this Converter.  # noqa: E501


        :return: The configuration of this Converter.  # noqa: E501
        :rtype: JsonNode
        """
        return self._configuration

    @configuration.setter
    def configuration(self, configuration):
        """Sets the configuration of this Converter.


        :param configuration: The configuration of this Converter.  # noqa: E501
        :type: JsonNode
        """

        self._configuration = configuration

    @property
    def additional_info(self):
        """Gets the additional_info of this Converter.  # noqa: E501


        :return: The additional_info of this Converter.  # noqa: E501
        :rtype: JsonNode
        """
        return self._additional_info

    @additional_info.setter
    def additional_info(self, additional_info):
        """Sets the additional_info of this Converter.


        :param additional_info: The additional_info of this Converter.  # noqa: E501
        :type: JsonNode
        """

        self._additional_info = additional_info

    @property
    def edge_template(self):
        """Gets the edge_template of this Converter.  # noqa: E501

        Boolean flag that specifies that is regular or edge template converter  # noqa: E501

        :return: The edge_template of this Converter.  # noqa: E501
        :rtype: bool
        """
        return self._edge_template

    @edge_template.setter
    def edge_template(self, edge_template):
        """Sets the edge_template of this Converter.

        Boolean flag that specifies that is regular or edge template converter  # noqa: E501

        :param edge_template: The edge_template of this Converter.  # noqa: E501
        :type: bool
        """

        self._edge_template = edge_template

    @property
    def version(self):
        """Gets the version of this Converter.  # noqa: E501


        :return: The version of this Converter.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Converter.


        :param version: The version of this Converter.  # noqa: E501
        :type: int
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Converter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Converter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
