# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard Professional Edition IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0PE
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six
from tb_rest_client.models.models_pe.menu_item import MenuItem  # noqa: F401,E501

class CustomMenuItem(MenuItem):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'icon': 'str',
        'menu_item_type': 'str',
        'link_type': 'str',
        'dashboard_id': 'str',
        'hide_dashboard_toolbar': 'bool',
        'url': 'str',
        'set_access_token': 'bool',
        'visible': 'bool',
        'pages': 'list[CustomMenuItem]'
    }
    if hasattr(MenuItem, "swagger_types"):
        swagger_types.update(MenuItem.swagger_types)

    attribute_map = {
        'name': 'name',
        'icon': 'icon',
        'menu_item_type': 'menuItemType',
        'link_type': 'linkType',
        'dashboard_id': 'dashboardId',
        'hide_dashboard_toolbar': 'hideDashboardToolbar',
        'url': 'url',
        'set_access_token': 'setAccessToken',
        'visible': 'visible',
        'pages': 'pages'
    }
    if hasattr(MenuItem, "attribute_map"):
        attribute_map.update(MenuItem.attribute_map)

    def __init__(self, name=None, icon=None, menu_item_type=None, link_type=None, dashboard_id=None, hide_dashboard_toolbar=None, url=None, set_access_token=None, visible=None, pages=None, *args, **kwargs):  # noqa: E501
        """CustomMenuItem - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._icon = None
        self._menu_item_type = None
        self._link_type = None
        self._dashboard_id = None
        self._hide_dashboard_toolbar = None
        self._url = None
        self._set_access_token = None
        self._visible = None
        self._pages = None
        self.discriminator = None
        self.name = name
        if icon is not None:
            self.icon = icon
        self.menu_item_type = menu_item_type
        if link_type is not None:
            self.link_type = link_type
        if dashboard_id is not None:
            self.dashboard_id = dashboard_id
        if hide_dashboard_toolbar is not None:
            self.hide_dashboard_toolbar = hide_dashboard_toolbar
        if url is not None:
            self.url = url
        if set_access_token is not None:
            self.set_access_token = set_access_token
        if visible is not None:
            self.visible = visible
        if pages is not None:
            self.pages = pages
        MenuItem.__init__(self, *args, **kwargs)

    @property
    def name(self):
        """Gets the name of this CustomMenuItem.  # noqa: E501

        Name of the menu item  # noqa: E501

        :return: The name of this CustomMenuItem.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CustomMenuItem.

        Name of the menu item  # noqa: E501

        :param name: The name of this CustomMenuItem.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def icon(self):
        """Gets the icon of this CustomMenuItem.  # noqa: E501

        URL of the menu item icon. Overrides 'materialIcon'  # noqa: E501

        :return: The icon of this CustomMenuItem.  # noqa: E501
        :rtype: str
        """
        return self._icon

    @icon.setter
    def icon(self, icon):
        """Sets the icon of this CustomMenuItem.

        URL of the menu item icon. Overrides 'materialIcon'  # noqa: E501

        :param icon: The icon of this CustomMenuItem.  # noqa: E501
        :type: str
        """

        self._icon = icon

    @property
    def menu_item_type(self):
        """Gets the menu_item_type of this CustomMenuItem.  # noqa: E501

        Type of menu item (LINK or SECTION). LINK type means item has no child items, SECTION type should have at least one child  # noqa: E501

        :return: The menu_item_type of this CustomMenuItem.  # noqa: E501
        :rtype: str
        """
        return self._menu_item_type

    @menu_item_type.setter
    def menu_item_type(self, menu_item_type):
        """Sets the menu_item_type of this CustomMenuItem.

        Type of menu item (LINK or SECTION). LINK type means item has no child items, SECTION type should have at least one child  # noqa: E501

        :param menu_item_type: The menu_item_type of this CustomMenuItem.  # noqa: E501
        :type: str
        """
        if menu_item_type is None:
            raise ValueError("Invalid value for `menu_item_type`, must not be `None`")  # noqa: E501
        allowed_values = ["LINK", "SECTION"]  # noqa: E501
        if menu_item_type not in allowed_values:
            raise ValueError(
                "Invalid value for `menu_item_type` ({0}), must be one of {1}"  # noqa: E501
                .format(menu_item_type, allowed_values)
            )

        self._menu_item_type = menu_item_type

    @property
    def link_type(self):
        """Gets the link_type of this CustomMenuItem.  # noqa: E501

        Type of menu item (URL or DASHBOARD)  # noqa: E501

        :return: The link_type of this CustomMenuItem.  # noqa: E501
        :rtype: str
        """
        return self._link_type

    @link_type.setter
    def link_type(self, link_type):
        """Sets the link_type of this CustomMenuItem.

        Type of menu item (URL or DASHBOARD)  # noqa: E501

        :param link_type: The link_type of this CustomMenuItem.  # noqa: E501
        :type: str
        """
        allowed_values = ["URL", "DASHBOARD"]  # noqa: E501
        if link_type not in allowed_values:
            raise ValueError(
                "Invalid value for `link_type` ({0}), must be one of {1}"  # noqa: E501
                .format(link_type, allowed_values)
            )

        self._link_type = link_type

    @property
    def dashboard_id(self):
        """Gets the dashboard_id of this CustomMenuItem.  # noqa: E501

        Id of the Dashboard to open, when user clicks the menu item  # noqa: E501

        :return: The dashboard_id of this CustomMenuItem.  # noqa: E501
        :rtype: str
        """
        return self._dashboard_id

    @dashboard_id.setter
    def dashboard_id(self, dashboard_id):
        """Sets the dashboard_id of this CustomMenuItem.

        Id of the Dashboard to open, when user clicks the menu item  # noqa: E501

        :param dashboard_id: The dashboard_id of this CustomMenuItem.  # noqa: E501
        :type: str
        """

        self._dashboard_id = dashboard_id

    @property
    def hide_dashboard_toolbar(self):
        """Gets the hide_dashboard_toolbar of this CustomMenuItem.  # noqa: E501

        Hide the dashboard toolbar  # noqa: E501

        :return: The hide_dashboard_toolbar of this CustomMenuItem.  # noqa: E501
        :rtype: bool
        """
        return self._hide_dashboard_toolbar

    @hide_dashboard_toolbar.setter
    def hide_dashboard_toolbar(self, hide_dashboard_toolbar):
        """Sets the hide_dashboard_toolbar of this CustomMenuItem.

        Hide the dashboard toolbar  # noqa: E501

        :param hide_dashboard_toolbar: The hide_dashboard_toolbar of this CustomMenuItem.  # noqa: E501
        :type: bool
        """

        self._hide_dashboard_toolbar = hide_dashboard_toolbar

    @property
    def url(self):
        """Gets the url of this CustomMenuItem.  # noqa: E501

        URL to open in the iframe, when user clicks the menu item  # noqa: E501

        :return: The url of this CustomMenuItem.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this CustomMenuItem.

        URL to open in the iframe, when user clicks the menu item  # noqa: E501

        :param url: The url of this CustomMenuItem.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def set_access_token(self):
        """Gets the set_access_token of this CustomMenuItem.  # noqa: E501

        Set the access token of the current user to a new dashboard  # noqa: E501

        :return: The set_access_token of this CustomMenuItem.  # noqa: E501
        :rtype: bool
        """
        return self._set_access_token

    @set_access_token.setter
    def set_access_token(self, set_access_token):
        """Sets the set_access_token of this CustomMenuItem.

        Set the access token of the current user to a new dashboard  # noqa: E501

        :param set_access_token: The set_access_token of this CustomMenuItem.  # noqa: E501
        :type: bool
        """

        self._set_access_token = set_access_token

    @property
    def visible(self):
        """Gets the visible of this CustomMenuItem.  # noqa: E501

        Mark if menu item is visible for user  # noqa: E501

        :return: The visible of this CustomMenuItem.  # noqa: E501
        :rtype: bool
        """
        return self._visible

    @visible.setter
    def visible(self, visible):
        """Sets the visible of this CustomMenuItem.

        Mark if menu item is visible for user  # noqa: E501

        :param visible: The visible of this CustomMenuItem.  # noqa: E501
        :type: bool
        """

        self._visible = visible

    @property
    def pages(self):
        """Gets the pages of this CustomMenuItem.  # noqa: E501

        List of child menu items  # noqa: E501

        :return: The pages of this CustomMenuItem.  # noqa: E501
        :rtype: list[CustomMenuItem]
        """
        return self._pages

    @pages.setter
    def pages(self, pages):
        """Sets the pages of this CustomMenuItem.

        List of child menu items  # noqa: E501

        :param pages: The pages of this CustomMenuItem.  # noqa: E501
        :type: list[CustomMenuItem]
        """

        self._pages = pages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomMenuItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomMenuItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
