# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard Professional Edition IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0PE
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six
from tb_rest_client.models.models_ce.notification_rule_trigger_config import NotificationRuleTriggerConfig  # noqa: F401,E501

class IntegrationLifecycleEventNotificationRuleTriggerConfig(NotificationRuleTriggerConfig):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'integration_types': 'list[str]',
        'integrations': 'list[str]',
        'notify_on': 'list[str]',
        'only_on_error': 'bool'
    }
    if hasattr(NotificationRuleTriggerConfig, "swagger_types"):
        swagger_types.update(NotificationRuleTriggerConfig.swagger_types)

    attribute_map = {
        'integration_types': 'integrationTypes',
        'integrations': 'integrations',
        'notify_on': 'notifyOn',
        'only_on_error': 'onlyOnError'
    }
    if hasattr(NotificationRuleTriggerConfig, "attribute_map"):
        attribute_map.update(NotificationRuleTriggerConfig.attribute_map)

    def __init__(self, integration_types=None, integrations=None, notify_on=None, only_on_error=None, *args, **kwargs):  # noqa: E501
        """IntegrationLifecycleEventNotificationRuleTriggerConfig - a model defined in Swagger"""  # noqa: E501
        self._integration_types = None
        self._integrations = None
        self._notify_on = None
        self._only_on_error = None
        self.discriminator = None
        if integration_types is not None:
            self.integration_types = integration_types
        if integrations is not None:
            self.integrations = integrations
        if notify_on is not None:
            self.notify_on = notify_on
        if only_on_error is not None:
            self.only_on_error = only_on_error
        NotificationRuleTriggerConfig.__init__(self, *args, **kwargs)

    @property
    def integration_types(self):
        """Gets the integration_types of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501


        :return: The integration_types of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :rtype: list[str]
        """
        return self._integration_types

    @integration_types.setter
    def integration_types(self, integration_types):
        """Sets the integration_types of this IntegrationLifecycleEventNotificationRuleTriggerConfig.


        :param integration_types: The integration_types of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["OCEANCONNECT", "SIGFOX", "THINGPARK", "TPE", "CHIRPSTACK", "PARTICLE", "TMOBILE_IOT_CDP", "HTTP", "MQTT", "PUB_SUB", "AWS_IOT", "AWS_SQS", "AWS_KINESIS", "IBM_WATSON_IOT", "TTN", "TTI", "AZURE_EVENT_HUB", "OPC_UA", "CUSTOM", "UDP", "TCP", "KAFKA", "AZURE_IOT_HUB", "APACHE_PULSAR", "RABBITMQ", "LORIOT", "COAP", "TUYA", "AZURE_SERVICE_BUS", "KPN"]  # noqa: E501
        if not set(integration_types).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `integration_types` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(integration_types) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._integration_types = integration_types

    @property
    def integrations(self):
        """Gets the integrations of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501


        :return: The integrations of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :rtype: list[str]
        """
        return self._integrations

    @integrations.setter
    def integrations(self, integrations):
        """Sets the integrations of this IntegrationLifecycleEventNotificationRuleTriggerConfig.


        :param integrations: The integrations of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :type: list[str]
        """

        self._integrations = integrations

    @property
    def notify_on(self):
        """Gets the notify_on of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501


        :return: The notify_on of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :rtype: list[str]
        """
        return self._notify_on

    @notify_on.setter
    def notify_on(self, notify_on):
        """Sets the notify_on of this IntegrationLifecycleEventNotificationRuleTriggerConfig.


        :param notify_on: The notify_on of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["CREATED", "STARTED", "ACTIVATED", "SUSPENDED", "UPDATED", "STOPPED", "DELETED", "FAILED", "DEACTIVATED"]  # noqa: E501
        if not set(notify_on).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `notify_on` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(notify_on) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._notify_on = notify_on

    @property
    def only_on_error(self):
        """Gets the only_on_error of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501


        :return: The only_on_error of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :rtype: bool
        """
        return self._only_on_error

    @only_on_error.setter
    def only_on_error(self, only_on_error):
        """Sets the only_on_error of this IntegrationLifecycleEventNotificationRuleTriggerConfig.


        :param only_on_error: The only_on_error of this IntegrationLifecycleEventNotificationRuleTriggerConfig.  # noqa: E501
        :type: bool
        """

        self._only_on_error = only_on_error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IntegrationLifecycleEventNotificationRuleTriggerConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IntegrationLifecycleEventNotificationRuleTriggerConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
