# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard Professional Edition IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0PE
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six
from tb_rest_client.models.models_pe.event_filter import EventFilter  # noqa: F401,E501

class RawDataEventFilter(EventFilter):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'server': 'str',
        'uuid': 'str',
        'message_type': 'str',
        'message': 'str'
    }
    if hasattr(EventFilter, "swagger_types"):
        swagger_types.update(EventFilter.swagger_types)

    attribute_map = {
        'server': 'server',
        'uuid': 'uuid',
        'message_type': 'messageType',
        'message': 'message'
    }
    if hasattr(EventFilter, "attribute_map"):
        attribute_map.update(EventFilter.attribute_map)

    def __init__(self, server=None, uuid=None, message_type=None, message=None, *args, **kwargs):  # noqa: E501
        """RawDataEventFilter - a model defined in Swagger"""  # noqa: E501
        self._server = None
        self._uuid = None
        self._message_type = None
        self._message = None
        self.discriminator = None
        if server is not None:
            self.server = server
        if uuid is not None:
            self.uuid = uuid
        if message_type is not None:
            self.message_type = message_type
        if message is not None:
            self.message = message
        EventFilter.__init__(self, *args, **kwargs)

    @property
    def server(self):
        """Gets the server of this RawDataEventFilter.  # noqa: E501

        String value representing the server name, identifier or ip address where the platform is running  # noqa: E501

        :return: The server of this RawDataEventFilter.  # noqa: E501
        :rtype: str
        """
        return self._server

    @server.setter
    def server(self, server):
        """Sets the server of this RawDataEventFilter.

        String value representing the server name, identifier or ip address where the platform is running  # noqa: E501

        :param server: The server of this RawDataEventFilter.  # noqa: E501
        :type: str
        """

        self._server = server

    @property
    def uuid(self):
        """Gets the uuid of this RawDataEventFilter.  # noqa: E501

        String value representing the uuid  # noqa: E501

        :return: The uuid of this RawDataEventFilter.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this RawDataEventFilter.

        String value representing the uuid  # noqa: E501

        :param uuid: The uuid of this RawDataEventFilter.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    @property
    def message_type(self):
        """Gets the message_type of this RawDataEventFilter.  # noqa: E501

        String value representing the message type  # noqa: E501

        :return: The message_type of this RawDataEventFilter.  # noqa: E501
        :rtype: str
        """
        return self._message_type

    @message_type.setter
    def message_type(self, message_type):
        """Sets the message_type of this RawDataEventFilter.

        String value representing the message type  # noqa: E501

        :param message_type: The message_type of this RawDataEventFilter.  # noqa: E501
        :type: str
        """

        self._message_type = message_type

    @property
    def message(self):
        """Gets the message of this RawDataEventFilter.  # noqa: E501

        String value representing the message  # noqa: E501

        :return: The message of this RawDataEventFilter.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this RawDataEventFilter.

        String value representing the message  # noqa: E501

        :param message: The message of this RawDataEventFilter.  # noqa: E501
        :type: str
        """

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RawDataEventFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RawDataEventFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
