# coding: utf-8

"""
    ThingsBoard REST API

     ThingsBoard Professional Edition IoT platform REST API documentation.  # noqa: E501

    OpenAPI spec version: 4.0.0PE
    Contact: info@thingsboard.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

#  Copyright 2025. ThingsBoard
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import pprint
import re  # noqa: F401

import six
from tb_rest_client.models.models_pe.device_profile_provision_configuration import DeviceProfileProvisionConfiguration  # noqa: F401,E501

class X509CertificateChainProvisionConfiguration(DeviceProfileProvisionConfiguration):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'certificate_reg_ex_pattern': 'str',
        'allow_create_new_devices_by_x509_certificate': 'bool'
    }
    if hasattr(DeviceProfileProvisionConfiguration, "swagger_types"):
        swagger_types.update(DeviceProfileProvisionConfiguration.swagger_types)

    attribute_map = {
        'certificate_reg_ex_pattern': 'certificateRegExPattern',
        'allow_create_new_devices_by_x509_certificate': 'allowCreateNewDevicesByX509Certificate'
    }
    if hasattr(DeviceProfileProvisionConfiguration, "attribute_map"):
        attribute_map.update(DeviceProfileProvisionConfiguration.attribute_map)

    def __init__(self, certificate_reg_ex_pattern=None, allow_create_new_devices_by_x509_certificate=None, *args, **kwargs):  # noqa: E501
        """X509CertificateChainProvisionConfiguration - a model defined in Swagger"""  # noqa: E501
        self._certificate_reg_ex_pattern = None
        self._allow_create_new_devices_by_x509_certificate = None
        self.discriminator = None
        if certificate_reg_ex_pattern is not None:
            self.certificate_reg_ex_pattern = certificate_reg_ex_pattern
        if allow_create_new_devices_by_x509_certificate is not None:
            self.allow_create_new_devices_by_x509_certificate = allow_create_new_devices_by_x509_certificate
        DeviceProfileProvisionConfiguration.__init__(self, *args, **kwargs)

    @property
    def certificate_reg_ex_pattern(self):
        """Gets the certificate_reg_ex_pattern of this X509CertificateChainProvisionConfiguration.  # noqa: E501


        :return: The certificate_reg_ex_pattern of this X509CertificateChainProvisionConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._certificate_reg_ex_pattern

    @certificate_reg_ex_pattern.setter
    def certificate_reg_ex_pattern(self, certificate_reg_ex_pattern):
        """Sets the certificate_reg_ex_pattern of this X509CertificateChainProvisionConfiguration.


        :param certificate_reg_ex_pattern: The certificate_reg_ex_pattern of this X509CertificateChainProvisionConfiguration.  # noqa: E501
        :type: str
        """

        self._certificate_reg_ex_pattern = certificate_reg_ex_pattern

    @property
    def allow_create_new_devices_by_x509_certificate(self):
        """Gets the allow_create_new_devices_by_x509_certificate of this X509CertificateChainProvisionConfiguration.  # noqa: E501


        :return: The allow_create_new_devices_by_x509_certificate of this X509CertificateChainProvisionConfiguration.  # noqa: E501
        :rtype: bool
        """
        return self._allow_create_new_devices_by_x509_certificate

    @allow_create_new_devices_by_x509_certificate.setter
    def allow_create_new_devices_by_x509_certificate(self, allow_create_new_devices_by_x509_certificate):
        """Sets the allow_create_new_devices_by_x509_certificate of this X509CertificateChainProvisionConfiguration.


        :param allow_create_new_devices_by_x509_certificate: The allow_create_new_devices_by_x509_certificate of this X509CertificateChainProvisionConfiguration.  # noqa: E501
        :type: bool
        """

        self._allow_create_new_devices_by_x509_certificate = allow_create_new_devices_by_x509_certificate

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(X509CertificateChainProvisionConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, X509CertificateChainProvisionConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
